package top.ninwoo.utils;

import org.junit.Assert;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;
import top.ninwoo.utils.config.DockerConfig;
import top.ninwoo.utils.entity.BridgePort;
import top.ninwoo.utils.entity.Ovs;
import top.ninwoo.utils.entity.OvsBridge;
import top.ninwoo.utils.service.OVSService;
import top.ninwoo.utils.util.OvsUtils;


import java.util.ArrayList;
import java.util.List;

@RunWith(SpringJUnit4ClassRunner.class)
@ContextConfiguration(classes = DockerConfig.class)
public class OVSServiceTests {
    @Autowired
    private OvsUtils ovsService;

    @Test
    public void testBasicFunc() {
        Assert.assertTrue(ovsService.isInstall());
        ovsService.showDetails();
    }

    /**
     * 这个测试没跑过
     */
    @Test
    public void testOvsParser() {
        String input = "72238dea-74f4-44c7-bba3-03cb71847197\n" +
                "    Bridge vnbr\n" +
                "        Port \"9e66d7fc5c254_l\"\n" +
                "            Interface \"9e66d7fc5c254_l\"\n" +
                "        Port \"8935ff9c8d914_l\"\n" +
                "            Interface \"8935ff9c8d914_l\"\n" +
                "        Port vnbr\n" +
                "            Interface vnbr\n" +
                "                type: internal\n" +
                "        Port \"abb221b99b8a4_l\"\n" +
                "            Interface \"abb221b99b8a4_l\"\n" +
                "    ovs_version: \"2.9.2\"";
        Ovs ovs = new Ovs();
        ovs.setId("72238dea-74f4-44c7-bba3-03cb71847197");
        List<OvsBridge> ovsBridges = new ArrayList<>();
        OvsBridge ovsBridge = new OvsBridge();
        ovsBridge.setBridgeId("vnbr");
        BridgePort port1 = BridgePort.builder().portId("9e66d7fc5c254_l").interfaceId("9e66d7fc5c254_l").build();
        BridgePort port2 = BridgePort.builder().portId("8935ff9c8d914_l").interfaceId("8935ff9c8d914_l").build();
        BridgePort port3 = BridgePort.builder().portId("vnbr").interfaceId("vnbr").build();
        BridgePort port4 = BridgePort.builder().portId("abb221b99b8a4_l").interfaceId("abb221b99b8a4_l").build();
        List<BridgePort> bridgePorts = new ArrayList<>();
        bridgePorts.add(port1);
        bridgePorts.add(port2);
        bridgePorts.add(port3);
        bridgePorts.add(port4);

        ovsBridge.setPorts(bridgePorts);
        ovsBridges.add(ovsBridge);
        ovs.setBridges(ovsBridges);

        ovs.setOvsVersion("2.9.2");

        Ovs ovsResult = ovsService.parseOvsString(input);
        //Assert.assertEquals(ovs, ovsResult);
        Assert.assertTrue(ovs.getBridges().get(0).equals(ovsResult.getBridges().get(0)));
        //System.out.println(ovsResult.equals(ovs));
    }

    @Test
    public void testString() {
        String s = "        Port \"9e66d7fc5c254_l\"\n";
        String valueInString = ovsService.getValueInString(s);
        System.out.println(valueInString);
    }

    @Test
    public void controlOvs() {
        Ovs ovs = ovsService.showDetails();
        System.out.println(ovs);
        String bridgeName = "vnbr5";
        ovsService.addBridge(bridgeName);
        ovsService.setBridgeProtocol(bridgeName, "OpenFlow13");
        ovsService.setController(bridgeName, "127.0.0.1", 6653);
        ovsService.delBridge(bridgeName);

    }
}
